// Software per scomporre un numero in fattori primi
// di Francesco Galgani (www.galgani.it)

// linguaggio di programmazione: C++

#include <iostream.h>

int genera_primo_succ(int x) { // argomento x = numero primo attuale
	if (x==2) return x = 3;
	else {
		x+=2;	// incrementa numero e controlla se ha divisori 
		for (int i=3; (i-1)<=(x/i); i+=2) { // ricerca divisori
			if (x%i==0) { // se trova un divisore, prova un altro num.
				x+=2; i=1; }
		}
		return x; // restituisce numero primo successivo
	}
}


void fattorizza (int n) {  // pr = fattore primo, esp = esponente
	for (int pr=2; pr<=n; pr=genera_primo_succ(pr)) {
		int esp=0;
		if (n%pr==0) { // se pr  divisore di n, allora...
			esp++; // incrementa esponente
			n/=pr; // divide il numero dato per il fattore pr
			while (n%pr==0) { // controlla se pr  ancora divis. di n
				esp++; // incrementa di nuovo l'esponente
				n/=pr; // ridivide il numero dato per il fattore pr
			}
		cout << pr << "^" << esp << endl;
		}
	}
}

void main() {
	cout << "Software per fattorizzare numeri naturali" << endl;
	cout << "Dammi un numero: ";
	int n;
	cin >> n;
	fattorizza(n);
}
